/*
 *      XCountdown - X version of the popular Channel 4 quiz show
 *
 * This software comes with NO warranty whatsoever. I therefore take no
 * responsibility for any damages, losses or problems caused through use
 * or misuse of this program.
 *
 * I hereby grant permission for this program to be freely copied and
 * distributed by any means, provided no charge is made for it.
 *
 * Matthew Chapman, csuoq@csv.warwick.ac.uk
 *    June 1995.
 */

/* config.h - system dependant defines - change as necessary */

/* Where the dictionary is to be found - you can use the given one,
   in src/OSPD_2-9.gz. DICTIONARY and DICTIONARY.gz are looked for, so the
   dictionary can be compressed with gzip.
*/
#define DICTIONARY "/opt/xcountdown/lib/OSPD_2-9"

/* make sure this is bigger than the number of words in the dictionary used -
   96100 is okay for the supplied dictionary.
*/
#define DICTSIZE 96100

/* Where the logo screen is to be found - it can be left gzipped. */
#define ABOUTXPMFILE "/opt/xcountdown/lib/X11/countdown.xpm"

/* timing for the clock - change for calibration. Each round should take
   CLOCK_DELAY/10 seconds, so 300 should give standard time.
*/
#define CLOCK_DELAY 300

/* Have you got a usleep function? If not src/usleep.c will be used. */
#define HAVE_USLEEP
