/*
 *      XCountdown - X version of the popular Channel 4 quiz show
 *
 * This software comes with NO warranty whatsoever. I therefore take no
 * responsibility for any damages, losses or problems caused through use
 * or misuse of this program.
 *
 * I hereby grant permission for this program to be freely copied and
 * distributed by any means, provided no charge is made for it.
 *
 * Matthew Chapman, csuoq@csv.warwick.ac.uk
 *    June 1995.
 */

/* globals.h - extern variables and functions */

void ChangeCarol(int newcarol);
void Quit();
void FinalQuit();

/* game.c */
void InitRound();
void UpdateScore(int ply,int amount);
void SmugMode(char *targ,char *longest);
void Wait(int delay);
void Click();
void ProcessEvent();
void KeyRedirect();
void Swap(int *first,int *second);

/* mess.c */
void DoMess(char *mess,int delay);
Boolean IsClear(void);
void WaitForMess(void);

/* menu.c */
void SetupMenu(Widget top, Widget title, int dnum);
void ConfirmQuit(int dnum);
void ClearNewGame(int dnum);

/* lettround.c */
void loaddict();
Boolean wordsearch(char *word);
char *search(char *targ,int start);
void InitPiles(void);
char GiveVowel(void);
char GiveConsonant(void);

/* xlettround.c */
void LettRound();
void DoLett(Widget w, XtPointer client_data, XtPointer call_data);

/* numround.c */
void Carol(int *list,int dest,char *solstr);
Boolean CheckEntry(String ans,int *list,int targ);

/* xnumround.c */
void NumRound(void);
void Tog(Widget w, XtPointer client_data, XtPointer call_data);
void Enter();

/* conundrum.c */
void pick_conun(char *orig,char *mixed);

/* xconundrum.c */
void Conun(void);
void Bing();


/* global variables */
extern XtAppContext app_context;
extern struct AppData app_data;
extern Widget topLevel,topl[NP],richard[NP],tclock[NP],lett[NP][NL][2];
extern Widget vbutt[NP],cbutt[NP],carol[NP];
extern Widget num[NP][7][4],cecil[NP],cnum[NP][6];
extern Widget input1[NP],name1[NP],score1[NP];
extern Widget input2[NP],name2[NP],score2[NP];

extern Widget tmaind[NP];
extern Pixmap bg_xpm[NP];
extern Colormap pseudo_cmap[NP];

/* for the numround popup */
extern Widget ptop[NP],ptitle[NP],pmain[NP];
extern Widget smtop[NP],smmain[NP];

extern Widget ctop[NP],cquit[NP],ccancel[NP];

/* colours */
extern char gray40[10],steelblue[10],gray70[10],gray90[10];

extern Display *dpy[NP];
extern int comp,round,letts_chosen,state;
extern int ply_go;
extern Boolean stop_the_clock,in_conundrum,doing_nums,waiting_for_names;
extern Boolean got_name[NP],new_game;

/* for the dictionary */
extern char dict[DICTSIZE][16];
extern int word_pos[15];

